<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>Closure xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../../../apidocs/org/eclipse/papyrus/designer/languages/cpp/cdt/texteditor/listener/Closure.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/*****************************************************************************</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * Copyright (c) 2013 CEA LIST.</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <em class="jxr_javadoccomment"> *  Ansgar Radermacher (CEA LIST) Ansgar.Radermacher@cea.fr - Initial API and implementation</em>
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <em class="jxr_javadoccomment"> *****************************************************************************/</em>
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.languages.cpp.cdt.texteditor.listener;
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.BasicEList;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.EList;
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.ecore.EObject;
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.ecore.EStructuralFeature.Setting;
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.common.util.UML2Util;
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Association;
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Classifier;
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Element;
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  <em class="jxr_javadoccomment"> * Calculate the closure of classifiers that need to be re-generated, if a</em>
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  <em class="jxr_javadoccomment"> * classifier changes</em>
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  <em class="jxr_javadoccomment"> * </em>
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  <em class="jxr_javadoccomment"> * There are two different reasons for the need to re-generate a classifier:</em>
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  <em class="jxr_javadoccomment"> * (1) one of the elements that it contains has changed</em>
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  <em class="jxr_javadoccomment"> * (2) an element outside the containment close is changed. An example is a superclass</em>
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  <em class="jxr_javadoccomment"> * that changes its name or an association target. In many cases, classifier depend</em>
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  <em class="jxr_javadoccomment"> * on names of outside elements, but the also require a regeneration if the element</em>
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  <em class="jxr_javadoccomment"> * is deleted.</em>
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  <em class="jxr_javadoccomment"> * We need to take the change-kind into account. E.g. if the name of an operation in A changes, we need to</em>
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  <em class="jxr_javadoccomment"> * re-generate class A, but we only need to regenerate class B (inheriting from A), if it actually</em>
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  <em class="jxr_javadoccomment"> * redefines that operation.</em>
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../../../org/eclipse/papyrus/designer/languages/cpp/cdt/texteditor/listener/Closure.html">Closure</a> {
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> EList&lt;Classifier&gt; calc(Classifier cl) {
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  		EList&lt;Classifier&gt; list = <strong class="jxr_keyword">new</strong> BasicEList&lt;Classifier&gt;();
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  		calc(cl, list);
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  		<strong class="jxr_keyword">return</strong> list;
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  	}
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> calc(Classifier cl, EList&lt;Classifier&gt; list) {
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  		<strong class="jxr_keyword">if</strong> (cl != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  			<strong class="jxr_keyword">for</strong> (Setting setting : UML2Util.getNonNavigableInverseReferences(cl)) {
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  				EObject eObj = setting.getEObject();
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  				<strong class="jxr_keyword">if</strong> (eObj instanceof Element) {
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  					Classifier referencedCl = nearestClassifier(eObj);
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  					<strong class="jxr_keyword">if</strong> (!list.contains(referencedCl) &amp;&amp; (!(referencedCl instanceof Association))) {
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  						list.add(referencedCl);
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  						calc(referencedCl, list);
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  					}
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  				}
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  			}
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  		}
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  	}
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">boolean</strong> isContained(EObject parent, EObject possibleChild) {
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  		<strong class="jxr_keyword">while</strong> (possibleChild != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  			<strong class="jxr_keyword">if</strong> (parent == possibleChild) {
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  				<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  			}
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  			possibleChild = possibleChild.eContainer();
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  		}
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  		<strong class="jxr_keyword">return</strong> false;
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  	}
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> Classifier nearestClassifier(EObject eObj) {
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  		<strong class="jxr_keyword">while</strong> (eObj != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  			<strong class="jxr_keyword">if</strong> (eObj instanceof Classifier) {
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  				<strong class="jxr_keyword">return</strong> (Classifier) eObj;
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  			}
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  			eObj = eObj.eContainer();
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  		}
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  	}
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
